#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2")

#define int long long

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define fi first
#define se second
#define rep(i,j,k) for (int (i) = (j); (i) < (k); ++i)
#define rrep(i,j,k) for (int (i) = (j); (i) >= (k); --i)
#define re return
#define pb push_back

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, less<>, null_type, rb_tree_tag, tree_order_statistics_node_update>;
using ordered_multiset = tree<int, less_equal<>, null_type, rb_tree_tag, tree_order_statistics_node_update>;
using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using pii = pair<int, int>;
using vpii = vector<pii>;
using vvpii = vector<vpii>;
using si = set<int>;
using msi = multiset<int>;

void amin(int& a, int b) {
    a = min(a, b);
}

void amax(int& a, int b) {
    a = max(a, b);
}

void solve();

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}

/* ------------------------------------- ACTUAL CODE STARTS HERE ------------------------------------- */

random_device rd;
mt19937 rnd(rd());

const int INF = 2e18;

int type, n, m;

int get_pos(int x, int tm, char c) {
    if (c == 'L') {
        if (x - 1 >= tm) {
            x -= tm;
            re x;
        }
        tm -= x - 1;
        tm %= 2 * (m - 1);
        x = 1;
        if (tm <= m - 1) {
            x += tm;
            re x;
        }
        x = n;
        tm -= m - 1;
        re x - tm;
    } else {
        if (m - x >= tm) {
            x += tm;
            re x;
        }
        tm -= m - x;
        tm %= 2 * (m - 1);
        x = m;
        if (tm <= m - 1) {
            re x - tm;
        }
        tm -= m - 1;
        x = 1;
        re x + tm;
    }
}

void solve() {
    cin >> type >> n >> m;
    vi a(n); for (int& x : a) cin >> x;
    sort(all(a));
    string s; cin >> s;
    int chet = a[0] % 2;
    rep(i, 0, n) {
        if (a[i] % 2 != chet) {
            cout << "No\n"; re;
        }
    }
    int cur_time = 0;
    if (s == "LL") {
        cur_time += a[0] - 1;
        int y = get_pos(a[1], a[0] - 1, 'L');
        int x = 1;
        a[0] = x;
        a[1] = y;
    } else if (s == "RR") {
        cur_time += m - a[1];
        int x = get_pos(a[0], m - a[1], 'R');
        int y = m;
        a[0] = x;
        a[1] = y;
    }
    cout << "Yes\n";
    if (type >= 2) {
        cout << (a[0] + a.back()) / 2 << "\n";
    }
    if (type == 3) {
        cout << 1 << "\n";
        cout << (a.back() - a[0]) / 2 + cur_time << " " << (a[0] + a.back()) / 2 << "\n";
    }
    /*if (type >= 2) {
        cout << (a[0] + a.back()) / 2 << "\n";
    }
    if (type == 3) {
        cout << 1 << "\n";
        cout << (a[0] + a.back()) / 2 - 1 << " " << (a[0] + a.back()) / 2 << "\n";
    }*/
}